// C++ code
//
// picks up enough coffee, then moves it to another location. finds the coffeepot based on ultrasonic sensor
// doesnt move until it gets enough pressure on spoon
#include <Servo.h> 

int triggerPin= 7; //ultrasonic sensor
int echoPin = 2; //ultrasonic sensor
int fsrPin = 0; // force sensor
int fsrReading =0; //initialize force reading
int distance; // initialize distance variable


Servo servo1; //set up each servo
Servo servo2;
 
int angle1 = 0;   // servo position in degrees - spoon servo
int angle2 = 0;   // arm rotating servo 
int limit = 0;    // variable used for servo2 movement
  
void setup() //only want this to run once, not necessary to be a continuous movement
{
  servo1.attach(9); //spoon servo
  servo2.attach(10); // rotating servo
  servo1.write(0); // original position of servo1
  servo2.write(angle1); //original position of servo2 
  Serial.begin(9600); //set up serial monitor


long duration, inches, cm; //set up distance measurements
  
 
  while (fsrReading<5) {     //when the spoon doesn't have enough coffee on it
    fsrReading = analogRead(fsrPin);  // read the force sensor 
 
  Serial.print("Analog reading = ");
  Serial.print(fsrReading);     // the force analog reading
    
    servo1.write(0);  // servo1 shouldn't move up
   
    servo2.write(45); //servo2 should scan surroundings until the reading is >15/finds more coffee
    //angle2++)
    fsrReading = analogRead(fsrPin); // read again
    
  }


  servo1.write(90); // rotate the spoon up to be parallel to the ground

    
digitalWrite(triggerPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin HIGH (ACTIVE) for 10 microseconds
  digitalWrite(triggerPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(triggerPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance = duration * 0.034 / 2; // Speed of sound wave divided by 2 (go and back)


   
  limit =0; //set variable to 0
  
  while (distance!=51) {    // until the distance is not equal to the distance the coffeepot is away, continue to look for it 
 delay(1);

    if (angle2==180) {      // if the angle of servo2 reaches its max, set the limit value to 1
      limit =1;
    }
    
    if (limit==0) {         // if the limit is 0, this means the angle is less than 180, and hasnt hit it yet
    servo2.write(angle2++); // continue to rotate towards 180
    
    }
      
    else if (limit ==1) {   // if the limit is 1, the angle has reached 180
    servo2.write(angle2--); // now the servo should sweep back towards 0 to continue looking for the coffeepot
    
    }
      

  // ultrasonic reading
  digitalWrite(triggerPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin HIGH (ACTIVE) for 10 microseconds
  digitalWrite(triggerPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(triggerPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance = duration * 0.034 / 2; // Speed of sound wave divided by 2 (go and back)
  // Displays the distance on the Serial Monitor
  Serial.print("Distance: ");
  Serial.print(distance);
  Serial.println(" cm");
  

    }
  
  servo1.write(0);// once distance is the correct value, dump the coffee
    delay(300);
  

};

void loop(){};
